=== debian/changelog ===
libsparrow (0.1-maemo1) unstable; urgency=low

   *Initial from upstream git (3caab73392028104c91105f9ea9fe5e1b2177882)
   *CFLAGS = -Os -DARMCPU -DFAST_MULTIPLICATION -DFAST_DIVISION
   *support ijkl as arrows (for non-uk N900 keyboards)
   *depends: libsdl-mixer1.2 >= 1:1.2.6-5+0m5+ogg+mp3-2 (earlier doesn't support ogg)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu, 11 Jun 2013 19:15:40 +0200
