=== debian/control ===
Source: libsparrow
Section: libs
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com> 
Build-Depends: debhelper (>= 5.0.42), libsdl1.2-dev, libsdl-image1.2-dev, libsdl-ttf2.0-dev, libsdl-mixer1.2-dev
Standards-Version: 3.8.1
Homepage: https://github.com/theZiz/sparrow3d

Package: libsparrow-dev
Section: libdevel
Architecture: any
Depends: libsparrow (= ${Source-Version})
Description: 

Package: libsparrow
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libsdl-mixer1.2 (>= 1:1.2.6-5+0m5+ogg+mp3-2)
Description:
